#
# Copyright (C) 2010 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Copyright (C) 2010 Ken VanDine <ken.vandine@canonical.com>
#
# Error dialog for Gwibber
#

import pygtk
try:
    pygtk.require("2.0") 
except:
    print "Requires pygtk 2.0 or later"
    exit

from . import resources

import gettext
from gettext import lgettext as _
if hasattr(gettext, 'bind_textdomain_codeset'):
    gettext.bind_textdomain_codeset('gwibber','UTF-8')
gettext.textdomain('gwibber')

import gtk

class GwibberErrorDialog(object):

    def __init__(self, message=""):
        self.ui = gtk.Builder()
        self.ui.add_from_file (resources.get_ui_asset("gwibber-error-dialog.ui"))
        self.ui.connect_signals(self)
        dialog = self.ui.get_object("error_dialog")
        gtk.icon_theme_add_builtin_icon("gwibber", 22,
            gtk.gdk.pixbuf_new_from_file_at_size(
            resources.get_ui_asset("gwibber.svg"), 24, 24))
        dialog.set_icon_name("gwibber")

        dialog.show_all()
        
        self.ui.get_object('message').set_label(message)

    def show_error_dlg(self, error_string):
	"""This Function is used to show an error dialog when
	an error occurs.
	error_string - The error string that will be displayed
	on the dialog.
	"""
	error_dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR
				, message_format=error_string
				, buttons=gtk.BUTTONS_OK)
	error_dlg.run()
	error_dlg.destroy()


    def on_error_dialog_destroy(self, widget, data=None):
        gtk.main_quit()

    def on_close_button_clicked(self, widget, data=None):
        gtk.main_quit()  
