#
# Copyright (C) 2010 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Copyright (C) 2010 Ken VanDine <ken.vandine@canonical.com>
#
# Error dialog for Gwibber
#

import pygtk
try:
    pygtk.require("2.0") 
except:
    print "Requires pygtk 2.0 or later"
    exit

from . import resources

import gettext
from gettext import lgettext as _
if hasattr(gettext, 'bind_textdomain_codeset'):
    gettext.bind_textdomain_codeset('gwibber','UTF-8')
gettext.textdomain('gwibber')

import gtk

class GwibberErrorDialog(object):

    def __init__(self):
        pass

    def show_dialog(self, message, title=None, type="error"):
        """show_dialog raises a gtk.MessageDialog to the user
           displaying errors or information.

           arguments are:
             message - a string to present to the user
             type - a string, must be either "error" or "info"
             title - OPTIONAL: a string which will set the title of the window
        """

        if type == "info":
            type = gtk.MESSAGE_INFO
        else:
            type = gtk.MESSAGE_ERROR

        if title is None:
            title = "Gwibber Error"
        dialog = gtk.MessageDialog(
            parent = None,
            type = type,
            buttons = gtk.BUTTONS_CLOSE,
            message_format = message)
        dialog.set_title(title)
        #dialog.set_size_request(320,100)
        dialog.set_position(gtk.WIN_POS_CENTER_ALWAYS)

        dialog.run()
        dialog.destroy()
        return

